// DCC Decoder for DS-DCC decode
// By yaasan
// Based on Nicolas's sketch http://blog.nicolas.cx
// Inspired by Geoff Bunza and his 17 Function DCC Decoder & updated library
//
//
// Debug serial output available on the serial port at baud 115200, aka Tools -> Serial Monitor
//



/*************************************************
 * 
 * Declaration of Symbols
 * 
 *************************************************/


#define MOTOR_PWM_A 9
#define MOTOR_PWM_B 10

#define MOTOR_LIM_MAX 255

/*************************************************
 * 
 * Declaration of Classes
 * 
 *************************************************/

/*************************************************
 * 
 * Declaration of Variables
 * 
 *************************************************/


typedef struct _MOTOR_PARAM
{
	byte mStartVoltage;
  byte mBEMFcoefficient;
	byte mPI_P;	
	byte mPI_I;	
  byte mBEMFcutoff;
} MOTOR_PARAM;
	
	


/*************************************************
 * 
 * Declaration of Functions
 * 
 *************************************************/

extern void MOTOR_Init();
extern void MOTOR_SetCV(byte iNo, byte inData);
extern void MOTOR_Sensor();
extern void MOTOR_Ack(void);
extern void MOTOR_Main(int inSpeedCmd, int inDirection);
int MOTOR_limitSpeed(int inSpeed);
int MOTOR_GetBEMF();

