// DCC Decoder for DS-DCC decoder
// By yaasan
//

#include <Arduino.h>
#include "motor_func.h"

/**
 * @fn
 * PIi[^j 10ms
 * @brief [^PIs
 * @param inValue ͒lB
 * @param inKp PQCB8d=1{B1/8`32{
 * @param inKi IQCB32d=1000ms. 31ms`8sec(8000ms)
 * @param *iopBuf Olobt@
 * @return ߂l̐
 * @detail ڍׂȐ
 */
 
int MOTOR_PI(int inValue, int inKp, int inKi, long *iopBuf)
{
	long aSignal;
	
	aSignal = ((inValue * inKp) >> 4) + ((inKi * (*iopBuf)) >> 8);    // MECY ReAdjust1 2016/05/01
		
	if( ((*iopBuf) <= 32767*2) && ((*iopBuf) >= -32768*2))            // MECY Readjust2 2016/05/01
	{
		(*iopBuf) += inValue;
	}
	
	return (int)aSignal;
}

int MOTOR_LPF(int inValue, int inT, long *iopBuf)
{
	
	(*iopBuf) = (((*iopBuf) * (256 - inT)) >> 8) + ( inT * inValue);
	
	return (*iopBuf) >> 8;
	
}



